====================
# Setup Armory
sudo apt-get install libcrypto++-dev swig python-twisted libqtcore4 libqt4-dev python-qt4
sudo pip install psutil qt4reactor

git clone https://github.com/etotheipi/BitcoinArmory armory

====================
# Get the data
https://www.dropbox.com/s/lxan3az5ob8vaaq/transactions.txt
transactions.txt is a dump of all transactions 

# Data is organized as follows: 
- hash: tx_hash
- prevout_hash: prevtxhash
- prevout_n: txoutindex
- pk: public key [hash or '(None)']
- index: number of tx outputs

- TxIn
  if prevout_hash == "\x00"*32:
    "in", hash, "coinbase", dt
  else:     
    "in", hash, prevout_hash, prevout_n, pk, dt

- TxOut
  "out", hash, index, pk, value/1e8, dt

====================
# Run the following
The dates are configurable in load_block_chain(): t1, t2 
t1 set to Jan 01, 2009
t2 set to Jul 13, 2011

PYTHONPATH=$PYTHONPATH:$HOME/armory/:$HOME/bitcoin/; python armory_block_reader.py --satoshi-datadir ~/.bitcoin

Full analysis on core-i7 with 16GB RAM, 24GB swap took ~14h18m (51468) seconds. 

====================
https://blockchain.info/charts/n-transactions-total?showDataPoints=true&timespan=all&show_header=true&daysAverageString=1&scale=0&format=csv&address=

As recorded by blockchain.info : 13/07/2011 18:15:05,1027155
comparable to ours             : 13/07/2011 00:00:00,1020117

====================
Pull python gephi graph streaming, and install graph streaming plugin in gephi
git@github.com:fuzzysingularity/pygephi_graphstreaming.git

====================
Page Rank on 25,545 nodes, 20,513 edges took 4.841173172 s (pure python)
Page Rank on 25,545 nodes, 20,513 edges took 0.21632194519 s (scipy sparse matrix)


===================
Other sources:
http://www.stanford.edu/class/cs224w/resources.html

===================
From http://compbio.cs.uic.edu/data/bitcoin/

File output description:
We generate the following files, with the included row specification:

pubkey_list.txt: [public_key_string]
transactionkey_list.txt: [transaction_key_string]

userkey_list.txt: [public_key1,public_key2,…,public_keyk]
user_edge_inputs.txt: [transaction_keyself,transaction_key1,…,transaction_keyk]
user_edge_inputs_public_keys.txt: [transaction_keyself,public_key1,public_keyk]
user_edges.txt: [transaction_keyself, user_keyfrom, user_keyto, date, value]
The first group of files, (“pubkey_list.txt”, “transactionkey_list.txt”) contains the lengthy text keys for public keys (i.e. “1EnHwdiKxvTE5AzcSnZqS52mMcHSLtCLwH”) and transaction keys (i.e. “5dc77144dcf46a7f76e369d406481e857be9e95b21375935832a5bed4e23633b”). Each ‘key’ field is a line number (starting at 1) to index into the appropriate list file. Using this, information on a public key or specific transaction can be queried on sites such as blockchain.info.

The second group of files (“userkey_list.txt”, “user_edge_inputs.txt”, “user_edge_inputs_public_keys.txt”) organizes the 'user' information, where a 'user' is a grouping of public keys inferred from public keys combined as inputs into a single transaction (meaning the user owns the private key to each address). This method is described in (Reid and Harrigan, 2011). Briefly, we create a graph where two public keys have an edge if they have been used as inputs in a single transaction. The connected components of this graph are 'users'.  Each line in “userkey_list.txt” is one of these components (a grouping of public keys). The files “user_edge_inputs.txt” and “user_edge_inputs_public_keys.txt” record the transaction keys, and public keys used as input to “this” transaction (see Figure 1).

The third group of files (“user_edges.txt”) is the primary network data file. The files “user_edges.txt”,  “user_edge_inputs.txt”, and “user_edge_inputs_public_keys.txt” share a transaction key field which allows them to be joined on.

See the relational model diagram “bitcoin_relational.pdf” summarizing these files. 
