# Define your item pipelines here
#
# Don't forget to add your pipeline to the ITEM_PIPELINES setting
# See: http://doc.scrapy.org/en/latest/topics/item-pipeline.html

from scrapy import signals
from scrapy.exceptions import DropItem
import json

class AggregatorPipeline(object):

    def __init__(self):
        self.addresses = {}
        self.file = open('output.json', 'wb')
        self.backupfile = open('backup-output.json', 'wb', 1)
        self.max_users = -1
        self.cur_users = 0

    def process_item(self, item, spider):
        if item["membername"][0] in self.addresses:
            self.addresses[item["membername"][0]].union(item["address"])
        else:
            self.addresses[item["membername"][0]] = item["address"]
            self.backupfile.write("%s\n" % json.dumps({item["membername"][0]:list(item["address"])}))
            self.cur_users += 1
        if self.cur_users == self.max_users:
            raise CloseSpider('count reached')
        else:
            return item

    def close_spider(self, spider):
        self.addresses.update((key, list(value)) for key,value in self.addresses.items())
        self.file.write(json.dumps(self.addresses))
        self.file.close()
